//  Copyright (c) 1999-2010  Pavel Rychly

#ifndef CONCCRIT_HH
#define CONCCRIT_HH

#include "concord.hh"

/**
 * criteria for sorting concordance or freq. distribution of concordance
 */
class Concordance::criteria {
public:
    char separator;
    const char *multisep;
    criteria(): separator('\t'), multisep (NULL) {}
    virtual ~criteria();
    virtual void push (Concordance *conc, ConcIndex idx, 
                      std::vector<std::string> &v) =0;
    virtual const char *get (Concordance *conc, ConcIndex idx,
                            bool case_retro=false) =0;
    virtual PosAttr *get_attr();
};

void 
prepare_criteria (Concordance *conc, const char *critstr, 
                 std::vector<Concordance::criteria*> &vec);


#endif

// vim: ts=4 sw=4 sta et sts=4 si cindent tw=80:
